#include <windows.h>
#include <commctrl.h>
#include "resource.h"
#include "common.h"
#include "rstring.h"
#include "spi.h"
#include "main.h"

struct spisettDlgVal{
	POINT plugins;

	POINT idok;
	POINT idcApply;
	POINT idcMoveup;
	POINT idcMovedown;
};

// {common.hsAcommctrl.hKvȂmain.cɁB
#ifndef ListView_SetCheckState
   #define ListView_SetCheckState(hwndLV, i, fCheck) \
      ListView_SetItemState(hwndLV, i, \
      INDEXTOSTATEIMAGEMASK((fCheck)+1), LVIS_STATEIMAGEMASK)
#endif

BOOL WINAPI SpisettingsDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		{
			HWND hListWnd = GetDlgItem(hWnd, IDC_PLUGINS);
			struct spisettDlgVal* sdv;

			// m
			SetWindowLong(hWnd, DWL_USER, (LONG)(sdv = halloc(sizeof(struct spisettDlgVal))));

			{
				RECT wrc, rc;
				POINT p;

				GetClientRect(hWnd, &wrc);

				GetWindowRect(GetDlgItem(hWnd, IDOK), &rc);
				p.x = rc.left;
				p.y = rc.top;
				ScreenToClient(hWnd, &p);
				p.x = wrc.right - p.x;
				//p.y = wrc.bottom - p.y;
				sdv->idok = p;

				GetWindowRect(GetDlgItem(hWnd, IDC_APPLY), &rc);
				p.x = rc.left;
				p.y = rc.top;
				ScreenToClient(hWnd, &p);
				p.x = wrc.right - p.x;
				//p.y = wrc.bottom - p.y;
				sdv->idcApply = p;

				GetWindowRect(GetDlgItem(hWnd, IDC_MOVEUP), &rc);
				p.x = rc.left;
				p.y = rc.top;
				ScreenToClient(hWnd, &p);
				p.x = wrc.right - p.x;
				//p.y = wrc.bottom - p.y;
				sdv->idcMoveup = p;

				GetWindowRect(GetDlgItem(hWnd, IDC_MOVEDOWN), &rc);
				p.x = rc.left;
				p.y = rc.top;
				ScreenToClient(hWnd, &p);
				p.x = wrc.right - p.x;
				//p.y = wrc.bottom - p.y;
				sdv->idcMovedown = p;

				GetWindowRect(GetDlgItem(hWnd, IDC_PLUGINS), &rc);	// Includes NonClientArea
				p.x = wrc.right - (rc.right - rc.left);	// g̃TCYZo
				p.y = wrc.bottom - (rc.bottom - rc.top);
				sdv->plugins = p;
			}

			// 낢Ƃ: FullRowSelectD
			ListView_SetExtendedListViewStyle(hListWnd, LVS_EX_CHECKBOXES | LVS_EX_FULLROWSELECT/* | LVS_EX_GRIDLINES*/);

			{
				LV_COLUMN lvc;

				lvc.mask = LVCF_TEXT | LVCF_WIDTH;
				lvc.cx = 100;
				lvc.pszText = String(IDS_PLUGINNAME);

				ListView_InsertColumn(hListWnd, 0, &lvc);

				lvc.cx = 350;
				lvc.pszText = String(IDS_PLUGINDESC);

				ListView_InsertColumn(hListWnd, 1, &lvc);
			}

			{
				SUSIEPLUGIN* spi;
				int i;

				// XgAbv
				for(spi = SPIroot, i = 0; spi; spi = spi->next, i++)
				{
					// TODO: Unicode
					LV_ITEM lvi;

					lvi.mask = LVIF_TEXT | LVIF_PARAM;
					lvi.iItem = i;
					lvi.iSubItem = 0;
					lvi.pszText = spi->ModuleName;
					lvi.lParam = (LPARAM)spi;

					ListView_InsertItem(hListWnd, &lvi);

					{
						CHAR ts[256];

						spi->GetPluginInfo(1, ts, sizeof(ts));

						ListView_SetItemText(hListWnd, lvi.iItem, 1, ts);
						ListView_SetCheckState(hListWnd, lvi.iItem, spi->use);
					}
				}
			}
		}

		return TRUE;
	case WM_COMMAND:
		if(LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hWnd, 0);
			break;
		}
		switch(LOWORD(wParam))
		{
		case IDC_APPLY:
			SPIroot = NULL;

			{
				HWND hListWnd = GetDlgItem(hWnd, IDC_PLUGINS);
				int max = ListView_GetItemCount(hListWnd);
				SUSIEPLUGIN* prespi = NULL;
				LV_ITEM lvi;

				lvi.mask = LVIF_PARAM;
				lvi.iSubItem = 0;

				for(lvi.iItem = 0; lvi.iItem < max; lvi.iItem++)
				{
					SUSIEPLUGIN* spi;

					ListView_GetItem(hListWnd, &lvi);

					spi = halloc(sizeof(SUSIEPLUGIN));
					*spi = *(SUSIEPLUGIN*)lvi.lParam;
					spi->use = ListView_GetCheckState(hListWnd, lvi.iItem);
					spi->next = NULL;

					if(!prespi)
						SPIroot = spi;
					else
						prespi->next = spi;

					prespi = spi;
				}
			}

			break;
		case IDC_MOVEUP:
			{
				HWND hListWnd = GetDlgItem(hWnd, IDC_PLUGINS);
				int i, max = ListView_GetItemCount(hListWnd);

				for(i = 1; i < max; i++)
				{
					if(ListView_GetItemState(hListWnd, i, LVIS_SELECTED) & LVIS_SELECTED)
					{
						LV_ITEM lvi;
						BOOL check;

						if(ListView_GetItemState(hListWnd, i - 1, LVIS_SELECTED) & LVIS_SELECTED)
							// ɂ͓܂
							continue;

						lvi.mask = LVIF_PARAM | LVIF_STATE;
						lvi.iItem = i;
						lvi.iSubItem = 0;
						lvi.stateMask = LVIS_SELECTED;
						ListView_GetItem(hListWnd, &lvi);
						check = ListView_GetCheckState(hListWnd, lvi.iItem);
						ListView_DeleteItem(hListWnd, i);
						lvi.iItem--;
						lvi.mask |= LVIF_TEXT;
						lvi.pszText = ((SUSIEPLUGIN*)lvi.lParam)->ModuleName;
						ListView_InsertItem(hListWnd, &lvi);
						ListView_SetCheckState(hListWnd, lvi.iItem, check);
						{
							CHAR ts[256];

							((SUSIEPLUGIN*)lvi.lParam)->GetPluginInfo(1, ts, sizeof(ts));

							ListView_SetItemText(hListWnd, lvi.iItem, 1, ts);
						}
					}
				}
			}
			break;
		case IDC_MOVEDOWN:
			{
				HWND hListWnd = GetDlgItem(hWnd, IDC_PLUGINS);
				int i, max = ListView_GetItemCount(hListWnd);

				for(i = max - 2; 0 <= i; i--)
				{
					if(ListView_GetItemState(hListWnd, i, LVIS_SELECTED) & LVIS_SELECTED)
					{
						LV_ITEM lvi;
						BOOL check;

						if(ListView_GetItemState(hListWnd, i + 1, LVIS_SELECTED) & LVIS_SELECTED)
							// ɂ͓܂
							continue;

						lvi.mask = LVIF_PARAM | LVIF_STATE;
						lvi.iItem = i;
						lvi.iSubItem = 0;
						lvi.stateMask = LVIS_SELECTED;
						ListView_GetItem(hListWnd, &lvi);
						check = ListView_GetCheckState(hListWnd, lvi.iItem);
						ListView_DeleteItem(hListWnd, i);
						lvi.iItem++;
						lvi.mask |= LVIF_TEXT;
						lvi.pszText = ((SUSIEPLUGIN*)lvi.lParam)->ModuleName;
						ListView_InsertItem(hListWnd, &lvi);
						ListView_SetCheckState(hListWnd, lvi.iItem, check);
						{
							CHAR ts[256];

							((SUSIEPLUGIN*)lvi.lParam)->GetPluginInfo(1, ts, sizeof(ts));

							ListView_SetItemText(hListWnd, lvi.iItem, 1, ts);
						}
					}
				}
			}
			break;
		}
		break;
	case WM_NOTIFY:
		{
			NMHDR* nmh = (NMHDR*)lParam;

			if(nmh->code == NM_DBLCLK)
			{
				HWND hListWnd = GetDlgItem(hWnd, IDC_PLUGINS);

				if(nmh->hwndFrom == hListWnd)
				{
					LV_ITEM lvi;

					lvi.mask = LVIF_PARAM;
					lvi.iSubItem = 0;
					if((lvi.iItem = ListView_GetNextItem(hListWnd, -1, LVNI_FOCUSED)) != -1)
					{
						ListView_GetItem(hListWnd, &lvi);

						if(((SUSIEPLUGIN*)lvi.lParam)->ConfigurationDlg)
						{
							if(((SUSIEPLUGIN*)lvi.lParam)->ConfigurationDlg(hWnd, 1) == -1)
								MessageBeep(MB_ICONASTERISK);
						}else
							MessageBeep(MB_ICONASTERISK);
					}
				}
			}
		}
		break;
	case WM_CLOSE:
		SendMessage(hWnd, WM_COMMAND, IDCANCEL, 0);
		break;
	case WM_DESTROY:
		{
			struct spisettDlgVal* sdv = (struct spisettDlgVal*)GetWindowLong(hWnd, DWL_USER);

			hfree(sdv);
		}
		break;
	case WM_SIZE:
		{
			struct spisettDlgVal* sdv = (struct spisettDlgVal*)GetWindowLong(hWnd, DWL_USER);

			SetWindowPos(GetDlgItem(hWnd, IDOK), NULL, LOWORD(lParam) - sdv->idok.x, /*HIWORD(lParam) - */sdv->idok.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			SetWindowPos(GetDlgItem(hWnd, IDC_APPLY), NULL, LOWORD(lParam) - sdv->idcApply.x, /*HIWORD(lParam) - */sdv->idcApply.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			SetWindowPos(GetDlgItem(hWnd, IDC_MOVEUP), NULL, LOWORD(lParam) - sdv->idcMoveup.x, /*HIWORD(lParam) - */sdv->idcMoveup.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			SetWindowPos(GetDlgItem(hWnd, IDC_MOVEDOWN), NULL, LOWORD(lParam) - sdv->idcMovedown.x, /*HIWORD(lParam) - */sdv->idcMovedown.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			SetWindowPos(GetDlgItem(hWnd, IDC_PLUGINS), NULL, 0, 0, LOWORD(lParam) - sdv->plugins.x, HIWORD(lParam) - sdv->plugins.y, SWP_NOZORDER | SWP_NOMOVE);
		}
		break;
	}

	return FALSE;
}
